What is CrossMerge

CrossMerge is a data synchronization tool that simplifies connecting to different types of databases and moving data between them, or between different locations.

With CrossMerge you can connect virtually any software package that uses a database with another database source within a couple of minutes. There's no need to make any modifications to the databases. No programming is needed, just point and click to connect your databases and move your data!

Figure A: CrossMerge supports virtually all database formats, including MS-SQL, IBM DB2, Pervasive.SQL, Oracle and DataFlex, as well as ODBC compliant databases such as Microsoft Access, Excel, MySQL, Informix, Progress, Interbase, and many others.


CrossMerge Editions

CrossMerge is available in three editions - Desktop, Consultant, and Server. Choose the edition that best meets your individual needs. New CrossMerge licenses include a one-year subscription at no additional charge.


DeskTop Edition

The Desktop Edition provides data connectivity for easily migrating information between databases, designed for anyone who needs to quickly and easily integrate data between disparate applications and back-end databases.

Licensed to one computer user, this edition requires a machine dependent unlock code to activate. The CrossMerge Connection Engine can only be activated by user intervention from the CrossMerge Connection Builder as a single "Collection". Evaluation mode is limited to the first 100 records of data transfer.


Consultant Edition

For application developers on the move servicing multiple clients, the Consultant Edition allows for consultants to use copies at their clients' sites for data conversions and merges for a period of up to 30 days, for an unlimited number of client-sites. Licensed to one consultant only. Not available as an evaluation download.
* Includes a Desktop Edition license for the consultant's continued personal use.


Server Edition

Licensed to one computer server only, requires machine dependant unlock code to activate automated CrossMerge Connection Engine. The CrossMerge Connection Engine may be run by the Windows Task Scheduler to automate the transfer of data defined by the connections. Evaluation mode is limited to the first 100 records of data transfer.
* Includes a Desktop Edition license for the administrator's use.


Annual Subscription

New CrossMerge licenses include a one-year subscription at no additional charge. The annual subscription starts on the date that the license is purchased. Customers may choose to renew the subscription annually.

An annual subscription provides CrossMerge customers with all of the updates, bug fixes and feature enhancements released for a period of one year. No additional maintenance or update fees are applicable to CrossMerge licenses covered by an annual subscription.


Quick Start Guide to Connect Two Database Tables

A connection of data between two database tables consists of two major steps. First a connect record for the two tables is created with this program, CrossMerge Builder. Secondly the CrossMerge Engine program is run with that record selected. The steps below outline this process.

  1. Launch CrossMerge Builder, if it is not already started.

  2. Ensure that the “1. Database Connections” tab page is active, and that the “Database Tables” tab page option is active.

  3. Select the database format for the source table, which is the table to be read. (For a Microsoft Access database, select Other (ODBC)). Depending on the format chosen you may need to enter a user name and password to login to the database. Select the table from the Table Name combo form.

  4. Do the same for the target table, which is the table to be updated with data from the source table.

  5. Click on the Fields/Column tab page and select the fields for the two tables that should be connected together, by one of the three field selection types available - Matching Field Names, Range of Field Numbers, or Selected Field Numbers.

  6. Click on the Index/Sorting tab page and select the index for the target table (bottom most group). From the list of available source fields, select the field(s) that should be used to feed the target table index with values to be able to do a find equal. This is necessary to be able to find an equal target table record when the two tables are compared during a run with the CrossMerge Engine.

  7. If the target table does not accept Null values (also known as undefined values) press the Apply for All Rows button on the Null Defaults tab page.

  8. Save the new record by pressing F2 or Ctrl+S and start the CrossMerge Engine from the toolbar.

  9. In the CrossMerge Engine Connect grid, select the record you just created (and de-select all others if necessary) and press the Start button. The CrossMerge Engine will now read through all the records in the source table and for each record try to see if there is a corresponding record in the target table. If there is not, a new target record will be created. Else the two records will be compared and if any of the selected fields has a value that is not the same in the two tables, the target table field(s) will be updated and the changed target record will be saved.

  10. Close the CrossMerge Engine and click the View Log tab page in the CrossMerge Builder (this program) and view the connection result created by the CrossMerge Engine. The most recent log record is displayed at the top of the list.


Using CrossMerge

Following is a detailed description of how to use the CrossMerge Builder and CrossMerge Engine.


CrossMerge Program Toolbar

Figure 1: The CrossMerge Program Toolbar.

Find Buttons

Use the Find buttons (First, Prev, Next, Last) to find a previously saved connection record. The cursor must be in either the Id or Sort Name field. Else the buttons are shadowed.

Search New/Clear Buttons

Alternatively to the Find buttons the Search button can be pressed to find a preciously saved connection record, or press F4. This will bring up a list with all connection records to select from. The New/Clear button must be pressed before a new connect record can be created, or press F5.

Save and Delete Buttons

Press the Save button to save a new or edited connect record. You may also press F2 or Ctrl+S. Press the Delete button to delete a connect record that no longer should be used, or press Shift+F2. Important: If you delete a connect record you need to revise all created Collection Names on the Database Connection Collections.

Edit Buttons

The Edit buttons are the normal Windows buttons for Cut, Copy and Paste. You may also use the short-cut keys Ctrl+X, Ctrl+C and Ctrl+V.

Connect Engine Button

This will start the CrossMerge Engine program that will connect data for connect records created in this program, or press Alt+C.

Properties Button

The Properties button brings up the Program Properties window. Here you can select the colours to use for lists and grids. Comprehensive tool tips is available when the mouse is hovering over an object. If the tool tips get in the way you can turn them off here.

Debug Mode checkbox - if you get program errors that seem to be bugs and that you would like to report, check the Debug Mode, try to recreate the error, make note of the line number shown in the error dialog and report it to us.

Use Login for this Program - click the checkbox, enter a user name and a password and the next time the program is started a login dialog will be displayed. You may alternatively press Alt+P.

Help Button

The Help button launches the CrossMerge Help documentation. You can also press F1.

About Button

The About button displays information about the CrossMerge software program, including program version, and contains buttons that link to more information about CrossMerge on the Web.


Database Connections Tab Page

Figure 2: Sample of Database Connection tab page. Note that several sub tab pages belong to this page.

Id: A unique Id for the record and is automatically generated. To find a created connection record use the Find buttons or the Search button in the toolbar or press F4 to bring up a list with saved connect records to choose from. Note: The records will be displayed by id number order in the Database Connection Collections grid and in the CrossMerge Engine program, i.e. in the order records are created in this program. Hint: If you need to reorder records you can use the Sort Name field.

Sort Name: If you want a different ordering of created connect records in the Database Connection Collections grid and in the CrossMerge Engine program, then the Id number, always enter a sort name here. To find a created connection record use the Find buttons or the Search button in the toolbar or press F4 to bring up a list with saved connect records to choose from.

Hide Record: Check to hide the connect record from the Database Connection Collections grid and the CrossMerge Engine program.

Description: A descriptive name for the connect record that will be displayed in Database Connection Collections grid and in the CrossMerge Engine program. Note: This will be filled automatically when both a source and target format and database tables has been selected.

Record Created: The date and time the connect record was created.

By: Indicates who the logged-in user was that created the connect record.


Database Tables Tab Page

The Database Tables tab page provides the set-up information for connecting the Source database with the Target Database.

Figure 3: Database Tables tab page.


Source Database Group

Contains all information about the source database table where data should be read from when connecting data.

Database Format: A list with the predefined selectable database formats. The layout of the Source Database group will change according to the format selected. Note: If you don’t find the particular database you need you can select ODBC – Open DataBase Connectivity and connect from there.

  • DataFlex
  • IBM DB2 Universal Database: The text changes to Data Source Name. Displays a list with IBM DB2 Universal Databases that has been configured for this machine. If you can’t find the requested Data Source Name in the list it needs to be configured with IBM’s Client Configuration Assistant program.
  • Microsoft SQL Server: A list with all Microsoft SQL Servers that is available on the network. If the database you are looking for is located on the current machine you can select (local) from the list. A Database Name list will also be displayed to the right. That list contains defined databases for the selected server.
  • ODBC – Open DataBase Connectivity: The text changes to Data Source Name. A new group will be displayed to the right: Select ODBC Data Source Type. There are three different types: a) User Data Sources b) System Data Sources c) File Data Sources. For each selected type the descriptive text below will change. If the type File Data Sources is selected, you need to select the file by pressing the Select File button in the group. The ODBC Admin button brings up Windows ODBC Administrator, where data sources can be added or edit.
  • Oracle: The native Oracle driver has not yet been brought up to date with the CrossMerge tool. If you need to connect to Oracle, select the ODBC database format and connect with an Oracle ODBC driver.
  • Pervasive.SQL (Btrieve): The text changes to Meta Database File. You may now press the Select File button to select a Pervasive file (filename.ddf). A Pervasive data-dictionary file contains all database tables for a set. If a data-dictionary file is missing for a set of tables, it needs to be created from Pervasive Control Center.

Server Name: The text and meaning will change according to the selected Database Format.

User Name: The user ID for logging into the database. This is not needed for all database systems. The CrossMerge Engine program will use the user name and password, when connecting data and when the View Data button is pressed.

Password: The password corresponding to the user name. This is not needed for all target database systems. If you fill in a password, you must also fill in the user name. Note: The entered password (if any) will be encrypted to the CrossMerge internal database.

Use NT Authentication: (Checkbox). Only used when database format Microsoft SQL Server is selected. Use NT Authentication when logging into the database. This is the same as using Windows login user name and password.

Schema Name: The text and meaning will change according to the selected Database Format.

  • DataFlex
  • IBM DB2 Universal Database: The name of the schema a table belongs to. A schema is a collection of names or objects. A schema can contain tables, views and triggers. Schemas provide a logical classification of objects in the database. If the keyword is not set the user id used to login to DB2 is used as the schema name.
  • Microsoft SQL Server: The text changes to Owner Name. The Database Owner (dbo) is a user that has implied permissions to perform all activities in the database. Any member of the sysadmin fixed server role who uses a database is mapped to the special user inside each database called dbo. Also, any object created by any member of the sysadmin fixed server role belongs to a dbo automatically.
  • ODBC – Open DataBase Connectivity: It all depends on the selected ODBC database. See the other descriptions in this paragraph.
  • Oracle: The native Oracle driver has not yet been brought up to date with the CrossMerge tool.
  • Pervasive.SQL (Btrieve)

Login Button: You can use the button to check if the entered user name and password are correct. As soon as the Table Name combo-form is dropped down a login attempt will be done automatically.

Table Path: Only applicable for database formats DataFlex and Pervasive.SQL (formerly known as Btrieve). Displays the full path to a file that has been selected with the Select File button.

Select File Button: Only available if any of the database formats DataFlex or Pervasive.SQL (Btrieve) has been selected. Pressing the button will bring up Windows Open File Dialog where you can select any DataFlex file (doesn’t need to be in any Filelist.cfg) or a File.ddf for Pervasive.SQL.

Table Name: Depending on the selected database format, the combo-form will display the available database tables. Select the table you want to use as the source data table.

View Data Button: If the login to the database was successful and the table was opened ok the View Data button will now be available to view data.

Data saved in ANSI format: The checkbox get selected automatically for all database formats except DataFlex. It is very important that this setting is correct. You can use the View Data button to inspect data.

Number of Records: The current physical number of records in the table. Note: For database formats other than DataFlex and Pervasive.SQL, press the Refresh button ( [image] ) located to the right of the display box or press Alt+R. The number of records is not automatically displayed when the table is opened for SQL databases due to the slow speed that this query takes for these databases.

Database Driver: The dynamic link library (.dll) database driver file that will be used for the connection. Most often there is only one alternative but there can be more.


Target Database Group

Contains all information about the target database table to connect data. All controls are the same as in the Source Database group except the Save data in ANSI format checkbox. This is the table that should be updated with data from the source table. You will later use Windows Scheduled Tasks to set up how often and when the update should take place for the two selected database tables.

Save data in ANSI format: It is very important that the checkbox is set to the right value. It controls in what format data will be saved in the target data table. ANSI represents Windows character set and is the most common format. If the checkbox is unchecked data will be saved in OEM format, also known as DOS format.


Fields/Columns Tab Page

Figure 4: Fields/Columns tab page.

Field Selection Type: There are three different types that can be selected: 1) Matching Field Names, 2) Range of Field Numbers, and 3) Selected Field Numbers.

Figure 5: Field Selection Type.

1) Matching Field Names: Will match all fields/columns for the source and target table that has the same field names. The fields do not need to be in the same order or be of the same type. The first four columns are specifications for the source table and the last four columns are for the target table. If any of the matching field names has a different type or length they will be displayed with a red colour in the grid. At the bottom of the grid the number of fields with the same name is displayed along with the total number of fields in the source table.

Figure 6: Matching Field Names.

2) Range of Field Numbers: This type is useful when there are a consecutive number of fields in the source and target tables that should be connected. The range of fields does not necessarily be in the same position in the source and target table. Select the first and last field in the source table that should be part of the connection and also the target table’s starting field.

Figure 7: Range of Field Numbers.

3) Selected Field Numbers: This is the most flexible format. The top left list contains all the fields for the source table that can be selected. Top right is the list with all fields that can be selected for the target table. Fields can be selected by double-clicking, pressing the enter key or spacebar. When a field is selected it is copied to the list below it and become a selected field. A field can also be inserted in the middle of already selected fields. To do this, click in the lower list at the position where the field should be inserted, then click on a field in the upper list that should be inserted and press the Ins (insert) key. The fields will be connected in the order they appear in the two selected lists. You may also append fields together from the source table to the target table. A typical use for this could be a source table that has one field for a person’s first name and a second field for the person’s last name and the target table has one field for both first and second name. In this case you would select the first name field from the source table list (left top), then click on the field in the source table list of selected fields (bottom left) and then click the Append Field button. From the popup dialog’s combo form you would select the field for the last name and press the OK button to close the dialog. The two fields will be trimmed together with one space in between. You may select as many fields you like to be appended together. Important: If you append together fields of type Numeric, their numeric values will be added together, not appended.

Figure 8: Selected Field Numbers.


Index/Sorting Tab Page

The Index/Sorting tab page is used for selecting the database fields to use for indexing and sorting the Source and Target databases.

Figure 9: Index/Sorting tab page.


Source Database Table Index Group

Settings in the Source Database Table Index group are unavailable when a new connect record is being created. For usage, read the text about the Target Database Table Index group below. See Auto Delete Old Records below for more information about when to use this feature.


Target Database Table Index Group

Select Unique Index: Select the index to use for the target table from the combo list to do a find equal search. This is needed to be able to update target records that has been changed in the source table. Then the source table fields that should be used to feed the target index should be selected. The top left list in the group contains available source table fields. The index can consist of a multi-segment index (or compound index), i.e. be build up by more than one field. The right bottom list displays the target index field segments. From the top left list select the field(s) that should be used for feeding the target table index segments. You select a field by double-clicking, pressing the enter key or the spacebar.

Auto Delete Old Records: (Checkbox) Check to delete target table records that no longer exist in the source table. If checked, the Source Database Table Index group becomes available. The deletion is handled through a second pass, this time finding all target table records and to check if there is a matching source table record. If checked, you also need to specify the source index load fields in the Source Database Table Index group above. Deletion will add considerably to the total connection time (about 60-70%) and it is therefore strongly suggested that a second connect record is created with this checked and that that connect record is run with the CrossMerge Engine e.g. once a day or something similar.


Filters Tab Page

Filters are used for specifying that only some records for the source table should be read during a connection phase with the CrossMerge Engine. You may specify as many filters as you like. Filters are additive, meaning that they are logically linked together with “AND”. An example of usage could be a source table that contains both customers and vendors and where a flag field that contains a 1 denotes that the record is customer and a 0 denotes the record is a vendor. Important: Beware how you set up the filters. This example shows two filters that would result in no records getting connected: “Constrain pcustomer.id < 5”, “Constrain pcustomer.id > 10”. Since filters are logically link together with “AND” and the value of the id field cannot be both less than 5 and greater than 10, this would never find any records to connect. See also Mark Source Rows that can be used in conjunction with filters.

Figure 10: Filters tab page.

Field Column Number: Select one of the source table fields from the combo list.

Mode: Select one of the logical operators from the combo list.

Value: Either enter a value or press the View Data button and double-click on a value or select a value and press enter.

Select Button: Press to add the specified filter to the list below.

Selected Filters list: When the Select button is pressed, the specified filter will be displayed here. Remove a filter from the list by pressing the Del key or by pressing Ctrl+X.


Null Defaults Tab Page

SQL represents the fact that some piece of information is missing by a special marker called a null. Columns that contain a null indicate it is not known what the real value is. Informally you can think of such columns as containing a null” or “being null.” One could argue that the term “null value” is nonsense because the whole point about nulls is that they are not values. We are aware of this argument but the term is commonly used within the database community so we will use it in this discussion. How nulls are actually represented in the system is implementation dependent. That implementation must (obviously) be so that the system can distinguish between null and non-null values. Null values complicate internal database logic by creating a three-valued logic as opposed to the normal two-valued (binary) logic. In normal logic operations, the result is either true or false. Using null values will add a third outcome, unknown. More importantly is that allowing null values in index columns has a negative impact on performance. Whether a column allows null values or not depends on the table definition.

Note: The Null Defaults Tab Page will be unavailable if either the DataFlex or Pervasive.SQL database formats have been selected.

Figure 11: Null Defaults tab page.

Null Defaults Grid: The grid contains all the fields in the target data table. Values can be entered in the last column in the grid only. The other columns are shadowed. You can manually enter a default value for each line in the grid or you can use the Default Null Values Group explained below.

Default Null Values Group: Default values are suggested for each field type depending on the target table’s database format. You can change the defaults to suit your needs and then press the Apply for All Rows button. Important: The apostrophes displayed for fields of type ASCII or Text will not be part of the default value. The apostrophes are only being used to display that a space character is going to be inserted whenever a null value is encountered in the source table. Note that even if some databases returns that a null value is ok, it might still not be true. The sample image above shows a Microsoft Access table and the fourth column is checked for all fields. This would denote that null values are ok for each field in this table, but in reality it is not and the connection would fail. It is therefore strongly recommended that null default values always be specified.


Value Conversion Tab Page

Value conversion is the process of automatically changing a field data value from the source table into something else in a target table field. An example could be a flag field has been defined as an ASCII field in the source table and that contains either a “Y” or an “N”. The target table on the other hand has a flag field defined as numeric and should either contain the value 1 or 0.

Figure 12: Value Conversion tab page.

Source Field: (Combo form). Select the source table field from the list.

Target Field: (Combo form). Select the target table field from the list.

Value Conversion Grid: Enter source table field values in the first column. Then enter the target table field value to change to. If the selected source table field is of type ASCII the Ignore Case checkbox can be checked to not distinguish between upper and lowercase values. You may enter as many rows with values in the grid as is appropriate. There can be one conversion table specified for each combination of source and target fields, see buttons below.

Create New Table: Even if rarely used, you may specify several conversion tables for the same source/target tables. To create a new conversion table, press the button, select another pair of source/target fields and enter the appropriate values in the conversion grid.

Search Buttons: If multiple conversion tables have been created click on the search buttons, between the Create New Table and Delete Table buttons, to see the other conversion tables.

Delete Table: Find a conversion table you want to delete with the Search Buttons and press the button to delete it if it no longer should be used.


Mark Source Rows Tab Page

The Mark Source Rows tab page works in the same way as the Filters tab page. The important difference is that it updates fields in the source data table. This can be used, for example, to update a flag field with a 1 during a run with the CrossMerge Engine. The Filters tab page would then probably contain a filter on the same field, but with the value of 0. This could be useful to speed up the connection process when the source table contains millions of records. It should be noted that for this process to be efficient, an index should have been defined for the selected source table field.

Figure 13: Mark Source Rows tab page.

Field/Column Number: For this and other controls on the tab page see the Filters tab page information above.


Other Tab Page

The Other tab page offers options for checking either the source or destination table layout for changes, and for entering descriptive text for the connect record.

Figure 14: Other tab page.

Check for Database Table Layout Changes: This is checked by default when creating a new connection record. If checked, it will ensure that a connection will not be performed if either the source or destination table layout has changed since the connect record was last created or edited. Potentially it could be harmful for the target data table if fields are changed in the source or target data table after the connection record was last saved to the CrossMerge tool’s internal database. To protect from this a snapshot of the source and target data table is taken whenever a connect record is saved (as long as the checkbox is checked), up and included the last field number that is included in the connection. Before each run with the CrossMerge Engine these snapshots will be compared to the current data table layout. If a change is encountered in a field name, type, length or precision, a warning will be written to the log and the CrossMerge Engine will gracefully continue with the next connect record, if any.

Note: You can enter whatever descriptive text for the connect record you like. This if for your memory only and will not be used by the CrossMerge Engine.


Collections of Database Connections Tab Page

This page enables the simple process of grouping together a number of created connect records and giving that collection a name for use when starting the CrossMerge Engine via Microsoft Scheduled Tasks (See CrossMerge Engine Tab Page). If you intend to schedule the CrossMerge Engine to run at specified time intervals, you need to create at least one collection name.

Figure 15: Database Tables Setup Collections tab page.

Collection Name Grid: You select a connection record by clicking on a row or by pressing the spacebar. The last column Auto Delete cannot be changed here. You need to change it on the Index/Sorting Tab Page.

Select All Button: (Upper right). Selects all grid rows.

Select None Button:Deselects all grid rows.

Invert Selection Button: All selected grid rows becomes unselected and vice versa.

Collection Name: (Combo list). Open the list to view previously saved collection names. Select one or more connect records in the grid and enter a name to denote the collection. The collection name can be entered on the command line for the CrossMerge Engine in Microsoft Scheduled Tasks.

Save Button: Save the new or edited collection.

Clear Button: You need to press the clear button prior to creating a new collection name. Then select the connect records from the grid, enter a collection name and press the save button.

Delete Button: Select a collection name from the combo form and press the button if the collection is no longer needed.


CrossMerge Engine Tab Page

This page provides for access to miscellaneous default settings for the CrossMerge Engine.

Figure 16: Connection Engine tab page.

Default Collection Name: Select the default collection name that should be used by the CrossMerge Engine from the list. The default collection name is used when the CrossMerge Engine is started manually via the programs toolbar.

Check ODBC DSN’s: If connection records has been created with the ODBC database format, you can optionally specify to check that these ODBC DSN (Data Source Name) exist before each run of the CrossMerge Engine. Enter each DSN with double quotations and separate each name with a space character.

Allow to change selections of items: When the CrossMerge Engine is started manually, this checkbox sets whether or not changes the selections are allowed.

Allow user to change Auto Delete items: When the CrossMerge Engine is started manually, this checkbox enables users to change the Auto Delete selections.

Display status panel with info while the CrossMerge Engine is running: This checkbox allows the display of a panel with status information on what tables and records are processed during a run with the CrossMerge Engine. If you unselect the checkbox, the information will be displayed in the status bar at the bottom of the program. However, there will be no way to cancel the process once it has been started.

Allow to cancel the CrossMerge Engine when run::If unchecked the status panel’s cancel button will be shadowed and the process cannot be interrupted once started.

Allow user to delete the connection log: The View Log tab page displays the connect log. The log has a maximum of five million records. Checking this option allows users to delete all records from the log.

Run Program Minimized when scheduled to Autorun by Windows Scheduled Tasks: When the CrossMerge Engine is started through Windows Scheduled Tasks to run at a predefined time, this option automatically minimizes the program.

Apply Button: After any changes have been made this button must be clicked to apply the changes.

Figure 17: Connection Engine tab page.

Help on how to Create a Windows Scheduled Task: Windows Scheduled Tasks does come with its own help documentation, but if you have never set up a task to auto-run, this Help will guide you step-by-step on how to create one for the CrossMerge Engine.

Start Windows Scheduled Tasks: This will start Windows Scheduled Tasks where you can create or edit tasks that should auto-run at a specific time and interval. If you never has done this before read the Help on how to Create a Windows Scheduled Task first.

Start the Connect Engine: Starts the CrossMerge Engine. This is the same as clicking on the icon in the toolbar.


View Log Tab Page

Each activity by the CrossMerge Engine is logged automatically to a log file. Important: It is crucial that you inspect the log now and then to see that the connection worked without problems. The log has a capacity of five million records so it might be a good idea to empty the log from time to time. The most recent log record is displayed at the top of the list. The first column is an automatic record id that is created along with the log record. The checkbox column is checked for each logged error. It cannot be changed. Connection status; Each run of the CrossMerge Engine will create several log records, and the first record always starts with the status Connection started, see image above. Each run will also end with the status text Ready. Time elapsed and the other log records are indented to be easier to read.

Figure 18: View Log Tab Page

The sample image above shows a typical number of Connect status texts when everything has gone as expected. If any errors were encountered the Error checkbox would be checked and a detailed explanation on what went wrong is written. The Record Id of the error record is also displayed. You may also see Warning messages here. A typical example would be a source table field that contained more data then what could fit in a target data field. In that case the warning message would display the source data that the CrossMerge Engine was trying to write to the target and what the result was.

Delete Log Button: Click this button to empty the log.


Using the CrossMerge Engine

The CrossMerge Engine, specifically, is the Windows application that connects data as instructed by each specific Database Connection record created in the CrossMerge Builder.

Following is a detailed description of how to use the CrossMerge Engine.


Connect Tab Page

Figure 19: Connect Tab Page

Selected Collection Name: Select a collection name from the drop down list. Different items in the grid are checked for the various collection names. You may or may not select any number of items to connect, by selecting the checkbox in the first column. If you can't change the selections it has been setup so in CrossMerge Builder (CMBuilder.exe). The selected tables will get connected when the Start button is pressed. If the “Auto Delete” column is enabled you may also select tables that should have “old” records removed. That is if records in the destination table exist, that no longer exists in the source table, they will be removed. Note: This will add considerably to the total process time and you probably only want to do this once in a while.

Select all button: Selects all items in the grid to be connected when the Start button is pressed. May be shadowed if you are not allowed to make changes.

Select none button: Deselects all checkboxes for records in the grid. May be shadowed if you are not allowed to make changes.

Invert selection button: Inverts current selection of checkboxes for selected items. May be shadowed if you are not allowed to make changes.

Start button: Starts the data connect process for the selected database tables (checkboxes).

Help button: Displays Help for the CrossMerge Engine. Note that the CrossMerge Builder uses a separate Help system.

About button: Displays information about the CrossMerge software program.


View Log Tab Page

Figure 20: View Log Tab Page

Log: All activity when the CrossMerge Engine is run will get logged. The first checkbox column is checked for each logged error. It cannot be changed. . The most recent log record is displayed topmost in the grid.

Delete Log button: Deletes all log file records. It is disabled if you are not allowed to delete the log.

Help button: Displays Help for the CrossMerge Engine. Note that the CrossMerge Builder uses a separate Help system.

About button: Displays information about the CrossMerge software program.


How to Create a Windows Scheduled Task

In order for the CrossMerge Engine to automatically run without user intervention, you must create a Windows Scheduled Task. The following is a guide for creating a Windows Scheduled Task in Windows 2000 Professional:

1. Click on the button Start Windows Scheduled Tasks button on the CrossMerge Engine tab page in CrossMerge Builder.

2. Double-click on Add Scheduled Task and the Scheduled Task Wizard will start:

3. Click the Next button.

4. Select CrossMerge Engine file Connect.exe from the list:

5. Enter a descriptive name for the task. It is recommended that a Collection Name be entered (see Database Connection Collections tab page):

6. Select parameters for when to run the CrossMerge Engine program:

7. Enter user name and password, then click Next:

8. Click the Open advanced properties... checkbox, then click Finish:

9. Type into the Run: form field after the text string “Connect.exe” the Collection Name within double quotes that you want to Autorun, as indicated in blue highlight below (see the Collections of Database Connections tab page for available collections you can use):

10. Click on the Security tab page. Depending on who is logged into the local computer when a Scheduled Task is created, group SYSTEM or Administrators need to be added. If this is the case, press the Add button. Else press the Apply button directly.

11. Select the SYSTEM group (or Administrators) and press OK and then the Apply button:

The scheduled task is now completed and will start the CrossMerge Engine program at the specified time. If you like to run the task repeatedly during a day, click on the Schedule tab page, click the Advanced button and click on the checkbox Repeat Task and fill in the necessary details.


Index

About, 7, 25

ANSI format, 11

Apply, 23

Auto Delete, 15, 22

Autorun, 22

Btrieve, 10

By, 8

cancel, 22

Clear, 7, 21

Collection Name, 21

Collection Name Grid, 21

Connect Engine, 7, 23

Connect tab page, 25

connection log, 22

Consultant Edition, 5

Create New Table, 18

CrossMerge Engine Tab Page, 22

CrossMerge Program Toolbar, 6

Database Connections Tab Page, 8

Database Driver, 11

Database Format, 9

Database Tables Tab Page, 8

DataFlex, 10, 11

Default Collection Name, 22

delete, 7, 15, 18, 22

Delete, 7, 15, 18, 21

Delete Log, 26

Description, 8

DeskTop Edition, 5

Edit, 7

Field Column Number, 16

Field Selection Type, 12

Fields/Columns Tab Page, 12

Filters Tab Page, 15, 16

Find, 6

Help, 7, 25

Hide Record, 8

IBM DB2 Universal Database, 9, 10

Id, 8

Index/Sorting Tab Page, 14

Invert selection, 25

Invert Selection, 21

Login, 7, 11

Mark Source Rows, 19

Matching Field Names, 12, 13

Microsoft SQL Server, 9, 10

Minimized, 22

Mode, 16

New/Clear, 7

Null Defaults, 6, 16, 17

Null Values, 17

Number of Records, 11

ODBC, 9, 10

ODBC DSN, 22

Open DataBase Connectivity, 9, 10

Oracle, 10

Other Tab Page, 19

Password, 10

Pervasive.SQL, 10, 11

Properties, 7

Range of Field Numbers, 12, 13

Record Created, 8

Save, 6, 7, 11, 21

Save data in ANSI format, 11

Schema Name, 10

Search, 7, 8, 18

Select, 6, 9, 10, 11, 13, 15, 16

Select all, 25

Select All, 21

Select File Button, 11

Select none, 25

Select None, 21

Selected Collection Name, 25

Selected Field Numbers, 13

Selected Filters, 16

Server Edition, 5

Server Name, 10

Sort Name, 8

Source Database Table Index Set-up Box, 14

Source Field, 18

Start, 25

status panel, 22

Subscription, 5

Table Name, 6, 11

Table Path, 11

Target Database Set-up Box, 11

Target Field, 18

Unique Index, 15

Use NT Authentication, 10

User Name, 10

Value, 16

Value Conversion, 17

Value Conversion Grid, 18

View Data, 10, 11

View Log tab page, 26

Windows Scheduled Task, 26

Windows Scheduled Tasks, 11, 22, 23


Table of Contents

Introduction. 4

What is CrossMerge. 4

CrossMerge Editions 4

DeskTop Edition. 5

Consultant Edition. 5

Server Edition. 5

Annual Subscription. 5

Quick Start Guide to Connect Two Database Tables. 5

Using CrossMerge. 6

CrossMerge Program Toolbar 6

Database Connections Tab Page. 8

Database Tables Tab Page. 8

Source Database Group. 9

Target Database Group. 11

Fields/Columns Tab Page. 12

Index/Sorting Tab Page. 14

Source Database Table Index Group. 14

Target Database Table Index Group. 15

Filters Tab Page. 15

Null Defaults Tab Page. 16

Value Conversion Tab Page. 17

Mark Source Rows Tab Page. 19

Other Tab Page. 19

Collections of Database Connections Tab Page. 20

CrossMerge Engine Tab Page. 22

View Log Tab Page. 23

Using the CrossMerge Engine. 24

Connect Tab Page. 25

View Log Tab Page. 26

How to Create a Windows Scheduled Task. 26

Index. 33